/* aanmeld_aanm.c, sign up for a given event.

 * Copyright (C) 2001,2002 M.C. Bezemer
 *
 * Licensed under the terms of the GNU General Public License.
 * ABSOLUTELY NO WARRANTY.
 * See the file `COPYING' in this directory.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include <cgic.h>

#include "untag.h"
#include "urlencode.h"
#include "urldecode.h"
#include "findvalue.h"
#include "tasquery.h"
#include "session.h"
#include "basicfunc.h"


int cgiMain(void)
{
	char session_id[35];
	char *studienummer=NULL;
	char *wachtwoord=NULL;
	char *tas_stud_id=NULL;
	char evn_soort[100];
	char tas_even_id[100];
	cgiFormResultType status;
	char *tasresponse=NULL;
	size_t tasresponse_len=0;
	char ot_evn_soort[100];
	char ot_tas_ople_id[100];
	char ot_vak_type[100];
	char ot_tas_vak_id[100];
	char ot_oe_code[100];
	char ot_van_datum[100];
	char ot_tot_datum[100];
	char aanmeld_opm[200];
	int status_error=0;

	status=cgiFormString("session_id",session_id,35);
	if (status!=cgiFormSuccess) {
		strcpy(session_id,"NULL-session");
	}

	OpenTAS_get_session_data(session_id, &studienummer,
				 &wachtwoord, &tas_stud_id);

	status=cgiFormString("tas_even_id",tas_even_id,100);
	if (status!=cgiFormSuccess) {
		status_error+=1;
	}
	status=cgiFormString("evn_soort",evn_soort,100);
	if (status!=cgiFormSuccess) {
		status_error+=2;
	}

	if (status_error) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		OpenTAS_navigate(session_id);
		fprintf(cgiOut,
			"Er is een fout opgetreden:<br>\n"
			"Ongeldig tas_even_id of ongeldige evn_soort.<br>\n"
			"</body>\n</html>\n");
		exit(0);
	}

	cgiFormString("ot_evn_soort",ot_evn_soort,100);
	cgiFormString("ot_tas_ople_id",ot_tas_ople_id,100);
	cgiFormString("ot_vak_type",ot_vak_type,100);
	cgiFormString("ot_tas_vak_id",ot_tas_vak_id,100);
	cgiFormString("ot_oe_code",ot_oe_code,100);
	cgiFormString("ot_van_datum",ot_van_datum,100);
	cgiFormString("ot_tot_datum",ot_tot_datum,100);

	cgiFormString("aanmeld_opm",aanmeld_opm,200);

	tas_query_init();
	tas_query_add("USERNAME=",0);
	tas_query_add(studienummer,1);
	tas_query_add("&PASSWORD=",0);
	tas_query_add(wachtwoord,1);
	tas_query_add("&request=EvnAan&evn_soort=",0);
	tas_query_add(evn_soort,1);
	tas_query_add("&tas_even_id=",0);
	tas_query_add(tas_even_id,1);
	tas_query_add("&aanmeld_opm=",0);
	tas_query_add(aanmeld_opm,1);
	tas_query_add("&tas_stud_id=",0);
	tas_query_add(tas_stud_id,1);

	if (do_tas_query(&tasresponse,&tasresponse_len)!=0) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		OpenTAS_navigate(session_id);
		fprintf(cgiOut,
			"Er is een fout opgetreden:<br>\n"
			"Communicatie met TAS-server mislukt (%s)<br>\n"
			"</body>\n</html>\n", untag(tasresponse));
		exit(0);
	}
	inittasresponse(tasresponse);

	OpenTAS_check_foutnr(session_id);

	OpenTAS_send_pagestart(1,1,0,NULL);
	OpenTAS_navigate(session_id);

	fprintf(cgiOut, "Je bent aangemeld.\n<br>\n<br>\n");
	fprintf(cgiOut, "Aanmeld-status: %s<br>\n",
		untag(findfirstvalue("aanmeld_status_tr")));
	fprintf(cgiOut, "Aanmeld-datum: %s<br>\n<p>\n",
		untag(findfirstvalue("aanmeld_datum")));

	OpenTAS_back_to_search_results(session_id, ot_evn_soort,
				       ot_tas_ople_id, ot_vak_type,
				       ot_tas_vak_id, ot_oe_code,
				       ot_van_datum, ot_tot_datum);

	fprintf(cgiOut,
		"<table><tr><td>\n"
		"<form action=\"aanmeld_sel.cgi\" method=\"post\">\n"
		"<input type=\"hidden\" name=\"session_id\" "
		"value=\"%s\">\n",
		untag(session_id));
	fprintf(cgiOut,
		"<br>"
		"<input type=\"submit\" value=\"Nieuwe selectie\">\n"
		"</form>\n"
		"</td></tr></table>\n");

	fprintf(cgiOut,
		"</body>\n</html>\n");

	return 0;
}
