/* aanmeld_det.c, read (and show) detailed information for selected event
 * from TAS database

 * Copyright (C) 2001,2002 M.C. Bezemer
 *
 * Licensed under the terms of the GNU General Public License.
 * ABSOLUTELY NO WARRANTY.
 * See the file `COPYING' in this directory.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include <cgic.h>

#include "untag.h"
#include "urlencode.h"
#include "urldecode.h"
#include "findvalue.h"
#include "tasquery.h"
#include "session.h"
#include "basicfunc.h"


int cgiMain(void)
{
	char session_id[35];
	char *studienummer=NULL;
	char *wachtwoord=NULL;
	char *tas_stud_id=NULL;
	char evn_soort[100];
	char tas_even_id[100];
	cgiFormResultType status;
	char *tasresponse=NULL;
	size_t tasresponse_len=0;
	char ot_evn_soort[100];
	char ot_tas_ople_id[100];
	char ot_vak_type[100];
	char ot_tas_vak_id[100];
	char ot_oe_code[100];
	char ot_van_datum[100];
	char ot_tot_datum[100];
	int status_error=0;
	char *temp=NULL;

	status=cgiFormString("session_id",session_id,35);
	if (status!=cgiFormSuccess) {
		strcpy(session_id,"NULL-session");
	}

	OpenTAS_get_session_data(session_id, &studienummer,
				 &wachtwoord, &tas_stud_id);

	status=cgiFormString("tas_even_id",tas_even_id,100);
	if (status!=cgiFormSuccess) {
		status_error+=1;
	}
	status=cgiFormString("evn_soort",evn_soort,100);
	if (status!=cgiFormSuccess) {
		status_error+=2;
	}

	if (status_error) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		OpenTAS_navigate(session_id);
		fprintf(cgiOut,
			"Er is een fout opgetreden:<br>\n"
			"Ongeldig tas_even_id of ongeldige evn_soort.<br>\n"
			"</body>\n</html>\n");
		exit(0);
	}

	cgiFormString("ot_evn_soort",ot_evn_soort,100);
	cgiFormString("ot_tas_ople_id",ot_tas_ople_id,100);
	cgiFormString("ot_vak_type",ot_vak_type,100);
	cgiFormString("ot_tas_vak_id",ot_tas_vak_id,100);
	cgiFormString("ot_oe_code",ot_oe_code,100);
	cgiFormString("ot_van_datum",ot_van_datum,100);
	cgiFormString("ot_tot_datum",ot_tot_datum,100);

	tas_query_init();
	tas_query_add("USERNAME=",0);
	tas_query_add(studienummer,1);
	tas_query_add("&PASSWORD=",0);
	tas_query_add(wachtwoord,1);
	tas_query_add("&request=EvnDet&evn_soort=",0);
	tas_query_add(evn_soort,1);
	tas_query_add("&tas_even_id=",0);
	tas_query_add(tas_even_id,1);
	tas_query_add("&tas_stud_id=",0);
	tas_query_add(tas_stud_id,1);

	if (do_tas_query(&tasresponse,&tasresponse_len)!=0) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		OpenTAS_navigate(session_id);
		fprintf(cgiOut,
			"Er is een fout opgetreden:<br>\n"
			"Communicatie met TAS-server mislukt (%s)<br>\n"
			"</body>\n</html>\n", untag(tasresponse));
		exit(0);
	}
	inittasresponse(tasresponse);

	OpenTAS_check_foutnr(session_id);

	OpenTAS_send_pagestart(1,1,0,NULL);
	OpenTAS_navigate(session_id);

        OpenTAS_back_to_search_results(session_id, ot_evn_soort,
				       ot_tas_ople_id, ot_vak_type,
				       ot_tas_vak_id, ot_oe_code,
				       ot_van_datum, ot_tot_datum);

//	fprintf(cgiOut,
//		"FIXME!\n<p>\n");

	fprintf(cgiOut,
		"<table border=\"0\" rules=\"none\" frame=\"void\" "
		"cellspacing=\"3\">\n");
	fprintf(cgiOut,
		"<tr><td>Activiteit:&nbsp;</td><td>%s</td></tr>\n",
		untag(findfirstvalue("evn_soort")));
	fprintf(cgiOut,
		"<tr><td>Verzorgende opleiding:&nbsp;</td><td>%s</td></tr>\n",
		untag(findfirstvalue("opleiding")));
	fprintf(cgiOut,
		"<tr><td>Vak:&nbsp;</td><td>%s",
		untag(findfirstvalue("vak_oms_ned")));
	fprintf(cgiOut,
		" (%s)</td></tr>\n",
		untag(findfirstvalue("oe_code")));
	
	OpenTAS_write_URL("vak_url",
			 "<tr><td>Webpage van vak:&nbsp;</td><td>",
			 "</td></tr>\n");

	fprintf(cgiOut,
		"<tr><td>Datum/tijd:&nbsp;</td><td>%s",
		untag(findfirstvalue("evn_datum")));
	fprintf(cgiOut,
		"&nbsp;&nbsp;&nbsp;%s</td></tr>\n",
		untag(findfirstvalue("tijd")));
	fprintf(cgiOut,
		"<tr><td>Omschrijving:&nbsp;</td><td>%s</td></tr>\n",
		untag(findfirstvalue("omschrijving")));
	fprintf(cgiOut,
		"<tr><td>Opmerking Ond.&amp;Stud.Adm.:&nbsp;</td>"
		"<td>%s</td></tr>\n",
		untag(findfirstvalue("opmerking")));
	fprintf(cgiOut, "<tr><td>&nbsp;</td><td></td></tr>\n");

	fprintf(cgiOut,
		"<tr><td>Vak (eng):&nbsp;</td><td>%s</td></tr>\n",
		untag(findfirstvalue("vak_oms_eng")));
	fprintf(cgiOut,
		"<tr><td>Studiepunten:&nbsp;</td><td>%s</td></tr>\n",
		untag(findfirstvalue("res_stpt")));
	fprintf(cgiOut,
		"<tr><td>Studiepunten (eur):&nbsp;</td><td>%s</td></tr>\n",
		untag(findfirstvalue("ects_stpt")));
	fprintf(cgiOut,
		"<tr><td>Studiebel. uren:&nbsp;</td><td>%s</td></tr>\n",
		untag(findfirstvalue("sbu")));
	fprintf(cgiOut, "<tr><td>&nbsp;</td><td></td></tr>\n");

	fprintf(cgiOut,
		"<tr><td>Aanmelden mogelijk tot:&nbsp;</td><td>%s</td></tr>\n",
		untag(findfirstvalue("datum_stop_aanmeld")));
	fprintf(cgiOut,
		"<tr><td>Status bij aanmelden:&nbsp;</td><td>%s</td></tr>\n",
		untag(findfirstvalue("std_aanmeld_status")));
	fprintf(cgiOut,
		"<tr><td>Afmelden mogelijk tot:&nbsp;</td><td>%s</td></tr>\n",
		untag(findfirstvalue("datum_stop_terugtrek")));
	fprintf(cgiOut,
		"<tr><td>Aantal aanmeldingen:&nbsp;</td><td>%s</td></tr>\n",
		untag(findfirstvalue("aanmeldingen")));
	fprintf(cgiOut, "<tr><td>&nbsp;</td><td></td></tr>\n");

	temp=findfirstvalue("aanmeld_status_tr");
	if (temp!=NULL) {
		if (strcmp(temp," ")!=0) {
			fprintf(cgiOut,
				"<tr><td>Status:&nbsp;</td><td>%s</td></tr>\n",
				untag(temp));
		}
	}

	temp=findfirstvalue("status");
	if (temp!=NULL) {
		if (strcmp(temp,"D")==0) {
			temp=findfirstvalue("aanmeld_status");
			if (temp!=NULL) {
				if (strcmp(temp,"I")==0) {
					fprintf(cgiOut,"<tr><td>Zaalindeling:</td><td></td></tr>\n");
				} else {
					fprintf(cgiOut,"<tr><td>Definitieve zaalindeling:</td><td></td></tr>\n");
				}
			} else {
				fprintf(cgiOut,"<tr><td>Fout: aanmeld_status veld ontbreekt.</td><td></td></tr>\n");
			}
		} else {
			fprintf(cgiOut,
				"<tr><td>Voorlopige zaalindeling:&nbsp;</td>");
			fprintf(cgiOut,
				"<td>(Definitieve zaalindeling verwacht op %s)</td></tr>\n",
				untag(findfirstvalue("datum_definitief")));
		}
	} else {
		fprintf(cgiOut,"<tr><td>Fout: status veld ontbreekt.</td><td></td></tr>\n");
	}

	fprintf(cgiOut,
		"<tr><td>Gebouw:&nbsp</td><td>%s",
		untag(findfirstvalue("gebouwnaam0")));
	fprintf(cgiOut,
		" (gebouwcode: %s)</td></tr>\n",
		untag(findfirstvalue("gebouwcode0")));
	fprintf(cgiOut,
		"<tr><td>Gebouwadres:&nbsp;</td><td>%s</td></tr>\n",
		untag(findfirstvalue("gebouwadres0")));
	fprintf(cgiOut,
		"<tr><td>Zaal:&nbsp;</td><td>%s",
		untag(findfirstvalue("zaalnaam0")));
	fprintf(cgiOut,
		" (zaalcode: %s)</td></tr>\n",
		untag(findfirstvalue("zaalcode0")));

	fprintf(cgiOut, "</table>\n");
	fprintf(cgiOut,
		"<table><tr><td>"
		"<form action=\"aanmeld_aanm.cgi\" method=\"post\">\n"
		"<input type=\"hidden\" name=\"session_id\" "
		"value=\"%s\">\n",
		untag(session_id));
	fprintf(cgiOut,
		"<input type=\"hidden\" name=\"ot_evn_soort\" "
		"value=\"%s\">\n",
		untag(ot_evn_soort));
	fprintf(cgiOut,
		"<input type=\"hidden\" name=\"ot_tas_ople_id\" "
		"value=\"%s\">\n",
		untag(ot_tas_ople_id));
	fprintf(cgiOut,
		"<input type=\"hidden\" name=\"ot_vak_type\" "
		"value=\"%s\">\n",
		untag(ot_vak_type));
	fprintf(cgiOut,
		"<input type=\"hidden\" name=\"ot_tas_vak_id\" "
		"value=\"%s\">\n",
		untag(ot_tas_vak_id));
	fprintf(cgiOut,
		"<input type=\"hidden\" name=\"ot_oe_code\" "
		"value=\"%s\">\n",
		untag(ot_oe_code));
	fprintf(cgiOut,
		"<input type=\"hidden\" name=\"ot_van_datum\" "
		"value=\"%s\">\n",
		untag(ot_van_datum));
	fprintf(cgiOut,
		"<input type=\"hidden\" name=\"ot_tot_datum\" "
		"value=\"%s\">\n",
		untag(ot_tot_datum));
	fprintf(cgiOut,
		"<input type=\"hidden\" name=\"evn_soort\" "
		"value=\"%s\">\n",
		untag(evn_soort));
	fprintf(cgiOut,
		"<input type=\"hidden\" name=\"tas_even_id\" "
		"value=\"%s\">\n",
		untag(tas_even_id));
	if (strcmp(findfirstvalue("opmerking_toegestaan"),"J")==0) {
		fprintf(cgiOut,
			"Eigen opmerking: (max 100 tekens)\n<br>\n"
			"<textarea name=\"aanmeld_opm\" cols=\"50\" "
			"rows=\"4\" wrap=\"off\"></textarea>\n");
	}
	fprintf(cgiOut,
		"<br>"
		"<input type=\"submit\" value=\"Aanmelden\">\n"
		"</form></td></tr></table>\n");


        OpenTAS_back_to_search_results(session_id, ot_evn_soort,
				       ot_tas_ople_id, ot_vak_type,
				       ot_tas_vak_id, ot_oe_code,
				       ot_van_datum, ot_tot_datum);

	fprintf(cgiOut,
		"</body>\n</html>\n");

	return 0;
}
