/* aanmeld_res.c, returns the result from a search operation, as issued
 * by aanmeld_sel.cgi.

 * Copyright (C) 2001,2002 M.C. Bezemer
 *
 * Licensed under the terms of the GNU General Public License.
 * ABSOLUTELY NO WARRANTY.
 * See the file `COPYING' in this directory.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include <cgic.h>

#include "untag.h"
#include "urlencode.h"
#include "urldecode.h"
#include "findvalue.h"
#include "tasquery.h"
#include "session.h"
#include "basicfunc.h"

//extern char **environ;


struct res_struct {
	char *evn_soort;	/* 1 */
	char *tas_even_id;	/* 2 */
	char *oe_code;		/* 3 */
	char *vak_oms_ned;	/* 4 */
	char *evn_datum;	/* 5 */
	char *evn_datum_sort;	/* 6 */
	char *tijd;		/* 7 */
};


int oecodecompare(struct res_struct *a, struct res_struct *b)
{
	int i;

	i=strcmp(a->oe_code, b->oe_code);

	return i;
}

int cgiMain(void)
{
	char session_id[35];
	char *studienummer=NULL;
	char *wachtwoord=NULL;
	char *tas_stud_id=NULL;
	char evn_soort[100];
	char tas_ople_id[100];
	char vak_type[100];
	char tas_vak_id[100];
	char oe_code[100];
	char van_datum[100];
	char tot_datum[100];
	cgiFormResultType status;
	char *tasresponse=NULL;
	size_t tasresponse_len=0;
	char *temppointer=NULL;
	int res_counter=0;
	struct res_struct *res_list=NULL;
	int i;

	status=cgiFormString("session_id",session_id,35);
	if (status!=cgiFormSuccess) {
		strcpy(session_id,"NULL-session");
	}

	OpenTAS_get_session_data(session_id, &studienummer,
				 &wachtwoord, &tas_stud_id);

	cgiFormString("evn_soort",evn_soort,100);
	cgiFormString("tas_ople_id",tas_ople_id,100);
	cgiFormString("vak_type",vak_type,100);
	cgiFormString("tas_vak_id",tas_vak_id,100);
	cgiFormString("oe_code",oe_code,100);
	cgiFormString("van_datum",van_datum,100);
	cgiFormString("tot_datum",tot_datum,100);

	tas_query_init();
	tas_query_add("USERNAME=",0);
	tas_query_add(studienummer,1);
	tas_query_add("&PASSWORD=",0);
	tas_query_add(wachtwoord,1);
	tas_query_add("&request=SelEvn&evn_soort=",0);
	tas_query_add(evn_soort,1);
	tas_query_add("&tas_ople_id=",0);
	tas_query_add(tas_ople_id,1);
	tas_query_add("&vak_type=",0);
	tas_query_add(vak_type,1);
	tas_query_add("&tas_vak_id=",0);
	tas_query_add(tas_vak_id,1);
	tas_query_add("&oe_code=",0);
	tas_query_add(oe_code,1);
	tas_query_add("&van_datum=",0);
	tas_query_add(van_datum,1);
	tas_query_add("&tot_datum=",0);
	tas_query_add(tot_datum,1);
	tas_query_add("&tas_stud_id=",0);
	tas_query_add(tas_stud_id,1);

	if (do_tas_query(&tasresponse,&tasresponse_len)!=0) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		OpenTAS_navigate(session_id);
		fprintf(cgiOut,
			"Er is een fout opgetreden:<br>\n"
			"Communicatie met TAS-server mislukt (%s)<br>\n"
			"</body>\n</html>\n", untag(tasresponse));
		exit(0);
	}
	inittasresponse(tasresponse);

	OpenTAS_check_foutnr(session_id);

	reset_tasvaluepointer();
	res_counter=0;
	while (findnextvalue("evn_soort")!=NULL) {
		res_counter++;
	}
	res_list=malloc((res_counter+1)*sizeof(struct res_struct));
	if (res_list==NULL) {
		OpenTAS_malloc_error(session_id);
	}

	reset_tasvaluepointer();
	for (i=0;i<res_counter;i++) {
		temppointer=findnextvalue("evn_soort");
		if (temppointer==NULL) {
			OpenTAS_invalid_tasdata(session_id);
		}
		res_list[i].evn_soort=strdup(temppointer);
		if (res_list[i].evn_soort==NULL) {
			OpenTAS_malloc_error(session_id);
		}
	}
	reset_tasvaluepointer();
	for (i=0;i<res_counter;i++) {
		temppointer=findnextvalue("tas_even_id");
		if (temppointer==NULL) {
			OpenTAS_invalid_tasdata(session_id);
		}
		res_list[i].tas_even_id=strdup(temppointer);
		if (res_list[i].tas_even_id==NULL) {
			OpenTAS_malloc_error(session_id);
		}
	}
	reset_tasvaluepointer();
	for (i=0;i<res_counter;i++) {
		temppointer=findnextvalue("oe_code");
		if (temppointer==NULL) {
			OpenTAS_invalid_tasdata(session_id);
		}
		res_list[i].oe_code=strdup(temppointer);
		if (res_list[i].oe_code==NULL) {
			OpenTAS_malloc_error(session_id);
		}
	}
	reset_tasvaluepointer();
	for (i=0;i<res_counter;i++) {
		temppointer=findnextvalue("vak_oms_ned");
		if (temppointer==NULL) {
			OpenTAS_invalid_tasdata(session_id);
		}
		res_list[i].vak_oms_ned=strdup(temppointer);
		if (res_list[i].vak_oms_ned==NULL) {
			OpenTAS_malloc_error(session_id);
		}
	}
	reset_tasvaluepointer();
	for (i=0;i<res_counter;i++) {
		temppointer=findnextvalue("evn_datum");
		if (temppointer==NULL) {
			OpenTAS_invalid_tasdata(session_id);
		}
		res_list[i].evn_datum=strdup(temppointer);
		if (res_list[i].evn_datum==NULL) {
			OpenTAS_malloc_error(session_id);
		}
	}
	reset_tasvaluepointer();
	for (i=0;i<res_counter;i++) {
		temppointer=findnextvalue("evn_datum_sort");
		if (temppointer==NULL) {
			OpenTAS_invalid_tasdata(session_id);
		}
		res_list[i].evn_datum_sort=strdup(temppointer);
		if (res_list[i].evn_datum_sort==NULL) {
			OpenTAS_malloc_error(session_id);
		}
	}
	reset_tasvaluepointer();
	for (i=0;i<res_counter;i++) {
		temppointer=findnextvalue("tijd");
		if (temppointer==NULL) {
			OpenTAS_invalid_tasdata(session_id);
		}
		res_list[i].tijd=strdup(temppointer);
		if (res_list[i].tijd==NULL) {
			OpenTAS_malloc_error(session_id);
		}
	}

	/* FIXME: sorteren (standaard op vakcode) */
	qsort(res_list,res_counter,sizeof(struct res_struct),(void*)oecodecompare);

	OpenTAS_send_pagestart(1,1,0,NULL);
	OpenTAS_navigate(session_id);

	fprintf(cgiOut,
		"Klik op 'Detail' voor details over de betreffende "
		"activiteit of op 'Aanmelden' om direct aan te melden.\n<p>\n"
		"<table border=\"0\" rules=\"none\" frame=\"void\" "
		"cellspacing=\"2\" cellpadding=\"1\">\n");
	fprintf(cgiOut,
		"<tr>\n<td></td><td></td><td>Activiteit&nbsp;</td><td>"
		"Vakcode&nbsp;</td><td>Omschrijving&nbsp;</td>"
		"<td>Datum&nbsp;</td><td>Tijd&nbsp;</td></tr>\n");

	for (i=0;i<res_counter;i++) {
		fprintf(cgiOut,
			"<tr>\n<td><a href=\"aanmeld_det.cgi?session_id=%s&",
			urlencode(session_id));
		fprintf(cgiOut,"ot_evn_soort=%s&",urlencode(evn_soort));
		fprintf(cgiOut,"ot_tas_ople_id=%s&",urlencode(tas_ople_id));
		fprintf(cgiOut,"ot_vak_type=%s&",urlencode(vak_type));
		fprintf(cgiOut,"ot_tas_vak_id=%s&",urlencode(tas_vak_id));
		fprintf(cgiOut,"ot_oe_code=%s&",urlencode(oe_code));
		fprintf(cgiOut,"ot_van_datum=%s&",urlencode(van_datum));
		fprintf(cgiOut,"ot_tot_datum=%s&",urlencode(tot_datum));
		fprintf(cgiOut,"evn_soort=%s&",
			urlencode(res_list[i].evn_soort));
		fprintf(cgiOut,"tas_even_id=%s",
			urlencode(res_list[i].tas_even_id));
		fprintf(cgiOut,"\">Detail</a>&nbsp;</td>\n<td>");

		fprintf(cgiOut,
			"<a href=\"aanmeld_aanm.cgi?session_id=%s&",
			urlencode(session_id));
		fprintf(cgiOut,"ot_evn_soort=%s&",urlencode(evn_soort));
		fprintf(cgiOut,"ot_tas_ople_id=%s&",urlencode(tas_ople_id));
		fprintf(cgiOut,"ot_vak_type=%s&",urlencode(vak_type));
		fprintf(cgiOut,"ot_tas_vak_id=%s&",urlencode(tas_vak_id));
		fprintf(cgiOut,"ot_oe_code=%s&",urlencode(oe_code));
		fprintf(cgiOut,"ot_van_datum=%s&",urlencode(van_datum));
		fprintf(cgiOut,"ot_tot_datum=%s&",urlencode(tot_datum));
		fprintf(cgiOut,"evn_soort=%s&",
			urlencode(res_list[i].evn_soort));
		fprintf(cgiOut,"tas_even_id=%s",
			urlencode(res_list[i].tas_even_id));
		fprintf(cgiOut,"\">Aanmelden</a>&nbsp;</td>\n<td>");

		fprintf(cgiOut,"%s&nbsp;</td><td>",
				untag(res_list[i].evn_soort));
		fprintf(cgiOut,"%s&nbsp;</td><td>",
				untag(res_list[i].oe_code));
		fprintf(cgiOut,"%s&nbsp;</td><td nowrap>",
				untag(res_list[i].vak_oms_ned));
		fprintf(cgiOut,"<nobr>%s&nbsp;</nobr></td><td nowrap>",
				untag(res_list[i].evn_datum));
		fprintf(cgiOut,"<nobr>%s&nbsp;</nobr></td></tr>\n",
				untag(res_list[i].tijd));
	}

	fprintf(cgiOut,"</table>\n<p>\n</body>\n</html>\n");

	return 0;
}
