/* overzicht_afm.c, try to withdraw from an event previously signed up for

 * Copyright (C) 2001,2002 M.C. Bezemer
 *
 * Licensed under the terms of the GNU General Public License.
 * ABSOLUTELY NO WARRANTY.
 * See the file `COPYING' in this directory.
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include <cgic.h>

#include "untag.h"
#include "urlencode.h"
#include "urldecode.h"
#include "findvalue.h"
#include "tasquery.h"
#include "session.h"
#include "basicfunc.h"


int cgiMain(void)
{
	char session_id[35];
	char *studienummer=NULL;
	char *wachtwoord=NULL;
	char *tas_stud_id=NULL;
	char evn_soort[100];
	char tas_even_id[100];
	cgiFormResultType status;
	char *tasresponse=NULL;
	size_t tasresponse_len=0;
	int status_error=0;

	status=cgiFormString("session_id",session_id,35);
	if (status!=cgiFormSuccess) {
		strcpy(session_id,"NULL-session");
	}

	OpenTAS_get_session_data(session_id, &studienummer,
				 &wachtwoord, &tas_stud_id);

	status=cgiFormString("tas_even_id",tas_even_id,100);
	if (status!=cgiFormSuccess) {
		status_error+=1;
	}
	status=cgiFormString("evn_soort",evn_soort,100);
	if (status!=cgiFormSuccess) {
		status_error+=2;
	}

	if (status_error) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		OpenTAS_navigate(session_id);
		fprintf(cgiOut,
			"Er is een fout opgetreden:<br>\n"
			"Ongeldig tas_even_id of ongeldige evn_soort.<br>\n"
			"</body>\n</html>\n");
		exit(0);
	}

	tas_query_init();
	tas_query_add("USERNAME=",0);
	tas_query_add(studienummer,1);
	tas_query_add("&PASSWORD=",0);
	tas_query_add(wachtwoord,1);
	tas_query_add("&request=EvnAfm&evn_soort=",0);
	tas_query_add(evn_soort,1);
	tas_query_add("&tas_even_id=",0);
	tas_query_add(tas_even_id,1);
	tas_query_add("&tas_stud_id=",0);
	tas_query_add(tas_stud_id,1);

	if (do_tas_query(&tasresponse,&tasresponse_len)!=0) {
		OpenTAS_send_pagestart(1,1,1,NULL);
		OpenTAS_navigate(session_id);
		fprintf(cgiOut,
			"Er is een fout opgetreden:<br>\n"
			"Communicatie met TAS-server mislukt (%s)<br>\n"
			"</body>\n</html>\n", untag(tasresponse));
		exit(0);
	}
	inittasresponse(tasresponse);

	OpenTAS_check_foutnr(session_id);
	OpenTAS_check_status_1(session_id);
	//Applet-foutnr: E_801

	OpenTAS_send_pagestart(1,1,0,NULL);
	OpenTAS_navigate(session_id);

	fprintf(cgiOut, "Je bent afgemeld.<br>\n");

	fprintf(cgiOut,
		"<table><tr><td>\n"
		"<form action=\"overzicht.cgi\" method=\"post\">\n"
		"<input type=\"hidden\" name=\"session_id\" "
		"value=\"%s\">\n",
		untag(session_id));
	fprintf(cgiOut,
		"<br>"
		"<input type=\"submit\" value=\"Terug naar het overzicht\">\n"
		"</form>\n"
		"</td></tr></table>\n");


	fprintf(cgiOut,
		"</body>\n</html>\n");

	return 0;
}
